﻿<div class="modal fade " data-backdrop="static" data-keyboard="false" id="BookModal" tabindex="-1" role="dialog" aria-labelledby="BookModal" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div id="divLoadingModal"></div>
        <div class="modal-content">
            <div class="modal-header clearfix">
                <button type="button" onclick="function close(){window.location.reload(true)};close()" class="btn btn-danger btn-xs pull-right"><span class="glyphicon glyphicon-remove"></span></button>
                <h4 class="modal-title text-center" style="color: darkblue;"><b>@Resources.Content.Book</b></h4>
            </div>
            <div class="modal-body">
                <div class="row">
                    <input id="bookid" name="bookid" type="text" style="display: none;" disabled="disabled" value="" class="form-control" />
                    <input id="bookroomid" name="bookroomid" type="text" style="display: none;" value="" class="form-control" />
                    <input id="guestid" name="guestid" type="text" style="display: none;" value="" class="form-control" />
                    <input id="exrate" name="exrate" type="text" style="display: none;" value="" class="form-control" />
                    <input id="bookingdate" name="bookingdate" type="date" style="display: none;" value="@DateTime.Now.ToString("yyyy'-'MM'-'dd")" class="form-control" />
                    <div class="col-md-6">
                        <div class="row">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="gnamekh">@Resources.Content.NameKh</label>
                                            <input id="gnamekh" name="gnamekh" placeholder="Enter Guest Name Khmer" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="guestname">@Resources.Content.Name</label>
                                            <input id="guestname" name="guestname" placeholder="Enter Guest Name" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>

                                        <div class="form-group">
                                            <label for="gsex">@Resources.Content.Sex</label>
                                            <select class="form-control input-sm" id="gsex">
                                                <option>Male</option>
                                                <option>Female</option>
                                            </select>
                                            @*<input id="gsex" name="gsex" placeholder="Enter Gender" type="text" value="" class="form-control input-sm" style="min-width: 100%" />*@
                                        </div>
                                        <div class="form-group">
                                            <label for="dob">@Resources.Content.DOB</label>
                                            <input id="dob" name="dob" type="date" value="@DateTime.Now.ToString("yyyy'-'MM'-'dd")" class="form-control input-sm" placeholder="Choose Datetime" />
                                            @*<input id="dob" name="dob" placeholder="Enter Date Of Birth" type="text" value="" class="form-control input-sm" style="min-width: 100%" />*@
                                        </div>
                                        <div class="form-group">
                                            <label for="address">មកពី</label>
                                            <input id="address" name="address" placeholder="Enter Address" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="nationality">@Resources.Content.Nationality</label>
                                            <select class="form-control input-sm" id="nationality">
                                                <option>Khmer</option>
                                                <option>Other</option>
                                            </select>
                                            @*<input id="nationality" name="nationality" placeholder="Enter Nationality" type="text" value="" class="form-control input-sm" style="min-width: 100%" />*@
                                        </div>
                                        <div class="form-group">
                                            <label for="phonenumber">@Resources.Content.Phone</label>
                                            <input id="phonenumber" name="phonenumber" placeholder="Enter Phone" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="email">@Resources.Content.Email</label>
                                            <input id="email" name="email" placeholder="Enter Email" type="email" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="ssn">@Resources.Content.SSN</label>
                                            <input id="ssn" name="ssn" placeholder="Enter Social Security Number" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="passport">@Resources.Content.Passport</label>
                                            <input id="passport" name="passport" placeholder="Enter Passport Number" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="row">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="bookingno">@Resources.Content.No</label>
                                            <input id="bookingno" readonly="readonly" name="bookingno" placeholder="Enter Book No" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="frmbookroomid" class="control-label">@Resources.Content.RoomNo</label>
                                            <select class="form-control input-sm" id="frmbookroomid">
                                                <option value="">---No Room Selected---</option>
                                                @foreach (var room in Model.ListRoomFree)
                                                {
                                                    <option value=@room.id>@room.room_no</option>
                                                }
                                            </select>

                                            <select class="form-control input-sm" id="rmid" disabled>
                                                @foreach (var room in Model.ListRoomBook)
                                                {
                                                    <option value=@room.id>@room.room_no</option>
                                                }
                                            </select>
                                        </div>
                                        <div class="form-group"> 
                                            
                                                <label id="lblChangeRoom">@Resources.Content.ChangeRoom <input type="checkbox" id="chbChangeRoom" onclick="ChangeRoom()" value="Hello"></label>
                                            
                                                <select class="form-control input-sm" id="changeroomid">
                                                    <option value="">--Change Room--</option>
                                                    @foreach (var room in Model.ListRoomFree)
                                                    {
                                                        <option value=@room.id>@room.room_no</option>
                                                    }
                                                </select>
                                        </div>
                                        <div class="form-group">
                                            <label for="roompriceb">@Resources.Content.RoomPrice</label>
                                            <input readonly="readonly" id="roompriceb" name="roompriceb" placeholder="$0.00" type="number" value="0" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="totalbooking">@Resources.Content.Total</label>
                                            <input oninput="TotalBook()" id="totalbooking" name="totalbooking" onfocus="this.select();" placeholder="$0.00" type="number" value="0" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label for="paydollarbooking">@Resources.Content.PayDollar</label>
                                            <input oninput="PayDeollarChange()" id="paydollarbooking" name="paydollarbooking" onfocus="this.select();" placeholder="$0.00" type="number" value="0" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="payreilbooking">@Resources.Content.PayRiel</label>
                                            <input id="payreilbooking" name="payreilbooking" placeholder="00" onfocus="this.select();" type="text" value="0" class="form-control input-sm" style="min-width: 100%" />
                                        </div>
                                        <div class="form-group">
                                            <label for="checkindate">@Resources.Content.CheckInDate</label>
                                            <input id="checkindate" name="checkindate" type="date" value="" class="form-control input-sm" placeholder="Choose Datetime" />
                                        </div>
                                        <div class="form-group">
                                            <label for="expiredate">@Resources.Content.ExpireDate</label>
                                            <input id="expiredate" onselect="ChangeExpierDate()" name="expiredate" type="date" value="" class="form-control input-sm" placeholder="Choose Datetime" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="bookingnote">@Resources.Content.Note</label>
                            <input id="bookingnote" name="bookingnote" placeholder="Note" type="text" value="" class="form-control input-sm" style="min-width: 100%" />
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" onclick="function close(){window.location.reload(true)};close()" data-dismiss="modal" class="btn btn-danger btn-sm pull-right" style="margin-left:5px;width:100px"><span class="glyphicon glyphicon-remove"></span> @Resources.Content.Close</button>
                <button type="button" id="btnAddBook" onclick="OnAddBook()" class="btn btn-info btn-sm pull-right" style="margin-left:5px;width:100px"><span class="glyphicon glyphicon-save"></span> @Resources.Content.Save</button>
                <button type="button" id="btnUpdateBook" onclick="OnUpdateBook()" class="btn btn-success btn-sm pull-right" style="margin-left:5px;width:100px"><span class="glyphicon glyphicon-refresh"></span> @Resources.Content.Update</button>
            </div>
        </div>

    </div>
</div>

<script>
    function ChangeExpierDate() {
        var expiredate = document.getElementById('expiredate');
        const EndDate = new Date();
        const StartDate = new Date(expiredate);
        const oneDay = 1000 * 60 * 60 * 24;
        const start = Date.UTC(EndDate.getFullYear(), EndDate.getMonth(), EndDate.getDate());
        const end = Date.UTC(StartDate.getFullYear(), StartDate.getMonth(), StartDate.getDate());
        var countday = (start - end) / oneDay;
        if (countday <= 0) {
            toastr.error("Input expire date incorrect!.", "Server Response");
            return false;
        }
            
    }

    function ChangeRoom() {
        var checkBox = document.getElementById("chbChangeRoom");
        if (checkBox.checked == true) {
            $('#changeroomid').show();
        } else {
            $('#changeroomid').hide();
        }
    }

    function TotalBook() {
        var a = $('#totalbooking').val();
        $('#paydollarbooking').val(a);
    }

    function PayDeollarChange() {
        var a = parseFloat($('#totalbooking').val());
        var b = parseFloat($('#paydollarbooking').val());
        var e = parseFloat($('#exrate').val());
        var re = (a - b) * e;
        $('#payreilbooking').val(re.toFixed(2).replace(/\d(?=(\d{3})+\.)/g, '$&,'));
    }

    ///Insert Guest
    function OnAddBook() {
        
        //if ($("#gnamekh").val() == "") {
        //    $("#gnamekh").focus()
        //    return false;
        //}
        //if ($("#guestname").val() == "") {
        //    $("#guestname").focus()
        //    return false;
        //}

        if ($("#checkindate").val() == "") {
            $("#checkindate").focus()
            return false;
        }
        if ($("#expiredate").val() == "") {
            $("#expiredate").focus()
            return false;
        }
        if ($("#frmbookroomid").val() == "") {
            $("#frmbookroomid").focus()
            return false;
        }

        var data = new FormData();
        data.append("name", $("#guestname").val());
        data.append("namekh", $("#gnamekh").val());
        data.append("sex", $("#gsex").val());
        data.append("dob", $("#dob").val());
        data.append("address", $("#address").val());
        data.append("nationality", $("#nationality").val());
        data.append("phone", $("#phonenumber").val());
        data.append("email", $("#email").val());
        data.append("ssn", $("#ssn").val());
        data.append("passport", $("#passport").val());
        data.append("status", 'Book');
        $.ajax({
            type: "POST",
            url: "/api/guests",
            contentType: false,
            processData: false,
            data: data,
            success: function (result) {
                Booking(result);
            },
            error: function (error) {
                toastr.error("Please check all selected field!.", "Server Response");
            }
        });
    }

    //Insert Booking
    function Booking(result) {
        if ($('#totalbooking').val() == "") {
            $('#totalbooking').focus()
            return false;
        }
        var data = {
            guestid: result,
            roomid: $('#frmbookroomid').val(),
            total: $('#totalbooking').val(),
            paydollar: $('#paydollarbooking').val(),
            payriel: $('#payreilbooking').val(),
            checkindate: $('#checkindate').val(),
            expiredate: $('#expiredate').val(),
            note: $('#bookingnote').val(),
        };
        $.ajax({
            url: "/api/bookings",
            data: JSON.stringify(data),
            type: "POST",
            contentType: "application/json;charset=utf-8",
            dataType: "json",
            success: function (result) {
                UpdateRoomStatus($('#frmbookroomid').val(), 'BOOK');
                toastr.success("Book successfully!", "Server Respond");
                window.location = "booking-rpt/" + result;
            },
            error: function (errormesage) {
                toastr.error("This Booking ID is exist in Database", "Server Respond");
            }
        });
    }


    //update booking
    function OnUpdateBook() {
        var checkBox = document.getElementById("chbChangeRoom");
        if (checkBox.checked == true) {
            if ($('#changeroomid').val() == "") {
                $('#changeroomid').focus();
                return false;
            }
        }

        UpdateBooking();
        UpdateGuest();
        if (checkBox.checked == true) {
            UpdateRoomStatus($('#rmid').val(),'FREE');
            UpdateRoomStatus($('#changeroomid').val(),'BOOK');
        } else {

        }
            
    }

    function UpdateBooking() {
        if ($('#totalbooking').val() == "") {
            $('#totalbooking').focus()
            return false;
        }
        var checkBox = document.getElementById("chbChangeRoom");
        var roomid;
        if (checkBox.checked == true) {
            roomid = $('#changeroomid').val();
        } else {
            roomid = $('#rmid').val();
        }

        var data = {
            id: $('#bookid').val(),
            bookingdate: $('#bookingdate').val(),
            guestid: $('#guestid').val(),
            roomid: roomid,
            total: $('#totalbooking').val(),
            paydollar: $('#paydollarbooking').val(),
            payriel: $('#payreilbooking').val(),
            checkindate: $('#checkindate').val(),
            expiredate: $('#expiredate').val(),
            note: $('#bookingnote').val(),
            status: 'Book',
        };
        $.ajax({
            url: "/api/bookings/" + data.id,
            data: JSON.stringify(data),
            type: "PUT",
            contentType: "application/json;charset=utf-8",
            dataType: "json",
            success: function (result) {
                toastr.success("Update record successfully!", "Service Response");
                window.location = "booking-rpt/" + data.id;
            },
            error: function (errormesage) {
                toastr.error("This Booking ID is exist in Database", "Server Respond");
            }
        });
    }

    function UpdateGuest() {
        var data = {
            id: $('#guestid').val(),
            name: $('#guestname').val(),
            namekh: $('#gnamekh').val(),
            sex: $('#gsex').val(),
            dob: $('#dob').val(),
            address: $('#address').val(),
            nationality: $('#nationality').val(),
            phone: $('#phonenumber').val(),
            email: $('#email').val(),
            ssn: $('#ssn').val(),
            passport: $('#passport').val(),
            status: 'Book',
        };
        $.ajax({
            url: "/api/Guests/" + data.id,
            data: JSON.stringify(data),
            type: "PUT",
            contentType: "application/json;charset=utf-8",
            dataType: "json",
            success: function (result) {
                //toastr.success("Updated successfully.", "Server Response");
                //window.location.reload(true);
            },
            error: function (errormessage) {
                toastr.error("Update Guest faild.", "Server Response");
            }
        });
    }

    function UpdateRoomStatus(id, st) {
        $.ajax({
            type: "PUT",
            url: "/api/updateroomstatus/" + id + "/"+st,
            contentType: false,
            processData: false,
            // data: status,
            success: function (result) {
                //toastr.success("Room Status has been Update successfully.", "Server Response");
            },
            error: function (error) {
                toastr.error("Update room status fail!", "Server Response");
            }
        });
    }
   
</script>



